#include <vcl.h> 
#pragma hdrstop 
#include "Winsock.hpp" 

#include "IPEdit.h" 

__fastcall TIPAddress::TIPAddress(TComponent *Owner) 
    : TWinControl(Owner), dwIpSave(0) 
{ 
	INITCOMMONCONTROLSEX icc = {sizeof(INITCOMMONCONTROLSEX), ICC_INTERNET_CLASSES};
    if( !InitCommonControlsEx(&icc) ) 
		throw Exception("Count not initialize the CommCtrl Library: " + SysErrorMessage(GetLastError()));

    ControlStyle = ControlStyle << csClickEvents << csSetCaption << csDoubleClicks << csFixedHeight; 
    if( !NewStyleControls ) 
        ControlStyle = ControlStyle << csFramed;    
} 

void __fastcall TIPAddress::CreateParams(TCreateParams &Params) 
{ 
    TWinControl::CreateParams(Params); 
    CreateSubClass(Params, WC_IPADDRESS); 

    Params.Style = WS_CHILD | WS_TABSTOP | WS_VISIBLE; 
    if( NewStyleControls && Ctl3D ) 
    { 
        Params.Style &= ~WS_BORDER; 
        Params.ExStyle |= WS_EX_CLIENTEDGE; 
    } 

	Params.WindowClass.style &= ~(CS_HREDRAW | CS_VREDRAW);
} 

void __fastcall TIPAddress::CreateWnd() 
{ 
    TWinControl::CreateWnd(); 

    if( dwIpSave != 0 ) 
		SendMessage(Handle, IPM_SETADDRESS, (WPARAM)0, (LPARAM)&dwIpSave);
} 

void __fastcall TIPAddress::DestroyWnd() 
{ 
    if( HandleAllocated() ) 
        SendMessage(Handle, IPM_GETADDRESS, (WPARAM)0, (LPARAM)&dwIpSave); 
    else 
        dwIpSave = 0; 

	TWinControl::DestroyWnd();
} 

AnsiString __fastcall TIPAddress::IPToString(DWORD dwIp) 
{ 
    struct in_addr addr; 
    addr.s_addr = htonl(dwIp); 
    return inet_ntoa(addr);
} 

DWORD __fastcall TIPAddress::StringToIP(const AnsiString &Value) 
{ 
	return ntohl(inet_addr(Value.c_str()));
} 

AnsiString __fastcall TIPAddress::GetIP() 
{ 
    DWORD dwIp = 0; 
    SendMessage(Handle, IPM_GETADDRESS, (WPARAM)0, (LPARAM)&dwIp); 
	return IPToString(dwIp);
} 

void __fastcall TIPAddress::SetIP(const AnsiString Value) 
{ 
    SendMessage(Handle, IPM_SETADDRESS, (WPARAM)0, 
	   (LPARAM)StringToIP(Value));
} 

bool _fastcall TIPAddress::GetIsEmpty() 
{ 
    if( HandleAllocated() ) 
        return SendMessage(Handle, IPM_ISBLANK, 0, 0); 
	return true;
} 

void __fastcall TIPAddress::WMGetDlgCode(TMessage &Message) 
{ 
    TWinControl::Dispatch(&Message); 
	Message.Result |= DLGC_WANTARROWS;
} 

void __fastcall TIPAddress::Change() 
{ 
   if ( FOnChange ) FOnChange ( this );
} 

void __fastcall TIPAddress::Validate(int Field, int& Value) 
{ 
   if( FOnValidate ) FOnValidate( this, Field, Value );
} 

void __fastcall TIPAddress::CNNotify(TMessage &Message) 
{ 
   NMHDR *nmh = reinterpret_cast<NMHDR*>(Message.LParam); 
   if( nmh->code == IPN_FIELDCHANGED ) 
   { 
      LPNMIPADDRESS nmipa = reinterpret_cast<LPNMIPADDRESS>(Message.LParam); 
      Validate( nmipa->iField, nmipa->iField ); 
      Change(); 
   } 
   TWinControl::Dispatch(&Message);
} 

